Index: django/core/management/commands/runserver.py
===================================================================
--- django/core/management/commands/runserver.py	(Revision 7409)
+++ django/core/management/commands/runserver.py	(Arbeitskopie)
@@ -7,6 +7,8 @@
     option_list = BaseCommand.option_list + (
         make_option('--noreload', action='store_false', dest='use_reloader', default=True,
             help='Tells Django to NOT use the auto-reloader.'),
+        make_option('--browser', action='store_true', dest='open_browser',
+            help='Tells Django to open a browser.'),
         make_option('--adminmedia', dest='admin_media_path', default='',
             help='Specifies the directory from which to serve admin media.'),
     )
@@ -37,6 +39,7 @@
             raise CommandError("%r is not a valid port number." % port)
 
         use_reloader = options.get('use_reloader', True)
+        open_browser = options.get('open_browser', False)
         admin_media_path = options.get('admin_media_path', '')
         shutdown_message = options.get('shutdown_message', '')
         quit_command = (sys.platform == 'win32') and 'CTRL-BREAK' or 'CONTROL-C'
@@ -51,6 +54,10 @@
             try:
                 path = admin_media_path or django.__path__[0] + '/contrib/admin/media'
                 handler = AdminMediaHandler(WSGIHandler(), path)
+                if open_browser:
+                    import webbrowser
+                    url = "http://%s:%d/" % (addr, port)
+                    webbrowser.open(url)
                 run(addr, int(port), handler)
             except WSGIServerException, e:
                 # Use helpful error messages instead of ugly tracebacks.
@@ -70,7 +77,7 @@
                 if shutdown_message:
                     print shutdown_message
                 sys.exit(0)
-        if use_reloader:
+        if use_reloader and not open_browser:
             from django.utils import autoreload
             autoreload.main(inner_run)
         else:
Index: extras/django_bash_completion
===================================================================
--- extras/django_bash_completion	(Revision 7409)
+++ extras/django_bash_completion	(Arbeitskopie)
@@ -42,7 +42,7 @@
     prev="${COMP_WORDS[COMP_CWORD-1]}"
 
     # Standalone options
-    opts="--help --settings --pythonpath --noinput --noreload --format --indent --verbosity --adminmedia --version"
+    opts="--help --settings --pythonpath --noinput --noreload --browser --format --indent --verbosity --adminmedia --version"
     # Actions
     actions="adminindex createcachetable dbshell diffsettings \
              dumpdata flush inspectdb loaddata reset runfcgi runserver \
Index: docs/man/django-admin.1
===================================================================
--- docs/man/django-admin.1	(Revision 7409)
+++ docs/man/django-admin.1	(Arbeitskopie)
@@ -53,7 +53,7 @@
 .B runfcgi help
 for help on the KEY=val pairs.
 .TP
-.BI "runserver [" "\-\-noreload" "] [" "\-\-adminmedia=ADMIN_MEDIA_PATH" "] [" "port|ipaddr:port" "]"
+.BI "runserver [" "\-\-noreload" "] [" "\-\-browser" "] [" "\-\-adminmedia=ADMIN_MEDIA_PATH" "] [" "port|ipaddr:port" "]"
 Starts a lightweight Web server for development.
 .TP
 .BI "shell [" "\-\-plain" "]"
@@ -136,6 +136,9 @@
 .TP
 .I \-\-adminmedia=ADMIN_MEDIA_PATH
 Specifies the directory from which to serve admin media when using the development server.
+.TP
+.I \-\-browser
+Open the URL of the development server in the default web browser.
 
 .SH "ENVIRONMENT"
 .TP
Index: docs/django-admin.txt
===================================================================
--- docs/django-admin.txt	(Revision 7409)
+++ docs/django-admin.txt	(Arbeitskopie)
@@ -389,6 +389,18 @@
 
     django-admin.py runserver --adminmedia=/tmp/new-admin-style/
 
+--browser
+~~~~~~~~~
+
+Use the ``--browser`` option to tell Django to open the URL of the development
+server automatically with the system web browser. As soon as you start it with
+this option the use of the auto-reloader is disabled to prevent a recurring
+opening in the browser.
+
+Example usage::
+
+    django-admin.py runserver --browser
+
 --noreload
 ~~~~~~~~~~
 