Index: django/oldforms/__init__.py
===================================================================
--- django/oldforms/__init__.py	(revision 7421)
+++ django/oldforms/__init__.py	(working copy)
@@ -953,7 +953,7 @@
         if match is not None:
             import re
             match_re = re.compile(match)
-        choices = not is_required and BLANK_CHOICE_DASH[:] or []
+        choices = not is_required and [BLANK_CHOICE_DASH] or []
         if recursive:
             for root, dirs, files in os.walk(path):
                 for f in files:
Index: django/db/models/fields/__init__.py
===================================================================
--- django/db/models/fields/__init__.py	(revision 7421)
+++ django/db/models/fields/__init__.py	(working copy)
@@ -28,8 +28,8 @@
 HORIZONTAL, VERTICAL = 1, 2
 
 # The values to use for "blank" in SelectFields. Will be appended to the start of most "choices" lists.
-BLANK_CHOICE_DASH = [("", "---------")]
-BLANK_CHOICE_NONE = [("", "None")]
+BLANK_CHOICE_DASH = ("", "---------")
+BLANK_CHOICE_NONE = ("", "None")
 
 # prepares a value for use in a LIKE query
 prep_for_like_query = lambda x: smart_unicode(x).replace("\\", "\\\\").replace("%", "\%").replace("_", "\_")
@@ -345,7 +345,7 @@
             val = None
         return val
 
-    def get_choices(self, include_blank=True, blank_choice=BLANK_CHOICE_DASH):
+    def get_choices(self, include_blank=True, blank_choice=[BLANK_CHOICE_DASH]):
         "Returns a list of tuples used as SelectField choices for this field."
         first_choice = include_blank and blank_choice or []
         if self.choices:
@@ -359,7 +359,7 @@
 
     def get_choices_default(self):
         if self.radio_admin:
-            return self.get_choices(include_blank=self.blank, blank_choice=BLANK_CHOICE_NONE)
+            return self.get_choices(include_blank=self.blank, blank_choice=[BLANK_CHOICE_NONE])
         else:
             return self.get_choices()
 
Index: django/utils/_decimal.py
===================================================================
--- django/utils/_decimal.py	(revision 7421)
+++ django/utils/_decimal.py	(working copy)
@@ -370,8 +370,8 @@
     """
 
 # List of public traps and flags
-_signals = [Clamped, DivisionByZero, Inexact, Overflow, Rounded,
-           Underflow, InvalidOperation, Subnormal]
+_signals = (Clamped, DivisionByZero, Inexact, Overflow, Rounded,
+           Underflow, InvalidOperation, Subnormal)
 
 # Map conditions (per the spec) to signals
 _condition_map = {ConversionSyntax:InvalidOperation,
@@ -2164,14 +2164,15 @@
 
 
 # get rounding method function:
-rounding_functions = [name for name in Decimal.__dict__.keys() if name.startswith('_round_')]
-for name in rounding_functions:
+for name in Decimal.__dict__.iterkeys():
+    if not name.startswith('_round_'):
+        continue
     #name is like _round_half_even, goes to the global ROUND_HALF_EVEN value.
     globalname = name[1:].upper()
     val = globals()[globalname]
     Decimal._pick_rounding_function[val] = name
 
-del name, val, globalname, rounding_functions
+del name, val, globalname
 
 class Context(object):
     """Contains the context for a Decimal instance.
Index: django/utils/html.py
===================================================================
--- django/utils/html.py	(revision 7421)
+++ django/utils/html.py	(working copy)
@@ -9,11 +9,11 @@
 from django.utils.http import urlquote
 
 # Configuration for urlize() function.
-LEADING_PUNCTUATION  = ['(', '<', '&lt;']
-TRAILING_PUNCTUATION = ['.', ',', ')', '>', '\n', '&gt;']
+LEADING_PUNCTUATION  = ('(', '<', '&lt;')
+TRAILING_PUNCTUATION = ('.', ',', ')', '>', '\n', '&gt;')
 
 # List of possible strings used for bullets in bulleted lists.
-DOTS = ['&middot;', '*', '\xe2\x80\xa2', '&#149;', '&bull;', '&#8226;']
+DOTS = ('&middot;', '*', '\xe2\x80\xa2', '&#149;', '&bull;', '&#8226;')
 
 unencoded_ampersands_re = re.compile(r'&(?!(\w+|#\d+);)')
 word_split_re = re.compile(r'(\s+)')
Index: django/utils/simplejson/decoder.py
===================================================================
--- django/utils/simplejson/decoder.py	(revision 7421)
+++ django/utils/simplejson/decoder.py	(working copy)
@@ -183,13 +183,13 @@
     return values, end
 pattern(r'\[')(JSONArray)
  
-ANYTHING = [
+ANYTHING = (
     JSONObject,
     JSONArray,
     JSONString,
     JSONConstant,
     JSONNumber,
-]
+)
 
 JSONScanner = Scanner(ANYTHING)
 